golang-1.13:
  image: golang:1.13
  stage: build
  script:
    - go version
    - go build .
    - go test .

golang-1.12:
  image: golang:1.12
  stage: build
  script:
    - go version
    - go build .
    - go test .

golang-1.11:
  image: golang:1.11
  stage: build
  script:
    - go version
    - go build .
    - go test .

golang-1.10:
  image: golang:1.10
  stage: build
  variables:
    GOPATH: $CI_BUILDS_DIR
    GIT_CLONE_PATH: $CI_BUILDS_DIR/src/gitlab.com/$CI_PROJECT_PATH
  script:
    - go version
    - go build gitlab.com/$CI_PROJECT_PATH
    - go test gitlab.com/$CI_PROJECT_PATH

golang-1.9:
  image: golang:1.9
  stage: build
  variables:
    GOPATH: $CI_BUILDS_DIR
    GIT_CLONE_PATH: $CI_BUILDS_DIR/src/gitlab.com/$CI_PROJECT_PATH
  script:
    - go version 
    - go build gitlab.com/$CI_PROJECT_PATH
    - go test gitlab.com/$CI_PROJECT_PATH

golang-1.8:
  image: golang:1.8
  stage: build
  variables:
    GOPATH: $CI_BUILDS_DIR
    GIT_CLONE_PATH: $CI_BUILDS_DIR/src/gitlab.com/$CI_PROJECT_PATH
  script:
    - go version 
    - go build gitlab.com/$CI_PROJECT_PATH
    - go test gitlab.com/$CI_PROJECT_PATH

test:
  image: golang:1.12
  stage: test
  variables:
    GOPATH: $CI_BUILDS_DIR
    GIT_CLONE_PATH: $CI_BUILDS_DIR/src/gitlab.com/$CI_PROJECT_PATH
  before_script:
    - mkdir -p .cache/github.com
    - mv .cache/github.com $GOPATH/src/
  after_script:
    - mv $GOPATH/src/github.com .cache/
  script:
    - go test -coverprofile=cover.out -v .
    - go tool cover -html=cover.out -o=cover.html
    - go vet .
    - go get -u github.com/gordonklaus/ineffassign
    - go install github.com/gordonklaus/ineffassign
    - $GOPATH/bin/ineffassign .
    - go get -u github.com/client9/misspell/cmd/misspell
    - go install github.com/client9/misspell/cmd/misspell
    - $GOPATH/bin/misspell -locale UK *.go *.md
    - go get -u github.com/securego/gosec/cmd/gosec
    - go install github.com/securego/gosec/cmd/gosec
    - $GOPATH/bin/gosec ./...
  cache:
    key: test
    paths:
      - .cache/github.com/
  except:
    - tags
  artifacts:
    paths:
      - cover.html

lint:
  image: golang:1.12
  stage: test
  variables:
    GOPATH: $CI_BUILDS_DIR
    GIT_CLONE_PATH: $CI_BUILDS_DIR/src/gitlab.com/$CI_PROJECT_PATH
  before_script:
    - mkdir -p .cache/pkg
    - mv .cache/pkg $GOPATH/pkg
  after_script:
    - mv $GOPATH/pkg .cache/
  script:
    - cd ..
    - GO111MODULE=on go get github.com/golangci/golangci-lint/cmd/golangci-lint@v1.17.1
    - GO111MODULE=on go install github.com/golangci/golangci-lint/cmd/golangci-lint
    - cd $GOPATH/src/gitlab.com/$CI_PROJECT_PATH
    - $GOPATH/bin/golangci-lint run -v .
  cache:
    key: lint
    paths:
      - .cache/pkg/
  except:
    - tags
  allow_failure: true

include:
  template: SAST.gitlab-ci.yml

pages:
  stage: deploy
  dependencies:
    - test
  script:
    - mkdir ./public
    - mv cover.html ./public
  only:
    - master
  artifacts:
    paths:
      - public
